diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/SAMDMessage.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/SAMDMessage.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/SAMDMessage.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/SAMDMessage.java	2017-09-18 11:07:29.491551000 +0900
@@ -0,0 +1,117 @@
+package android.service.samd;
+
+import android.os.Parcel;
+import android.os.Parcelable;
+
+import java.io.Serializable;
+
+/**
+ * Created by sbj on 17. 6. 26.
+ */
+public class SAMDMessage implements Serializable, Parcelable {
+    int fromDN;
+    int toDN;
+    String fromDip;
+    String toDip;
+    String message;
+
+
+    long stime;
+    long etime;
+
+    public SAMDMessage(){
+
+    }
+    public SAMDMessage(int _fromDN, int _toDN, String _message){
+        this.fromDN = _fromDN;
+        this.toDN = _toDN;
+        this.message = _message;
+        this.stime = 0;
+        this.etime = 0;
+    }
+    public SAMDMessage(int _fromDN, int _toDN, String _fromDip, String _toDip, String _message){
+        this.fromDN = _fromDN;
+        this.toDN = _toDN;
+        this.fromDip = _fromDip;
+        this.toDip = _toDip;
+        this.message = _message;
+        this.stime = 0;
+        this.etime = 0;
+    }
+
+    public int getFromDN(){
+        return this.fromDN;
+    }
+    public int getToDN(){
+        return this.toDN;
+    }
+    public String getFromDip(){
+        return this.fromDip;
+    }
+    public String getToDip(){
+        return this.toDip;
+    }
+    public String getMessage(){
+        return this.message;
+    }
+    public long getStime(){
+        return this.stime;
+    }
+    public long getEtime(){
+        return this.etime;
+    }
+    public void setStime(long s){
+        this.stime = s;
+    }
+
+    public void setEtime(long e){
+        this.etime = e;
+    }
+
+    public SAMDMessage(Parcel in)
+    {
+        this.fromDN = in.readInt();
+        this.toDN = in.readInt();
+        this.fromDip = in.readString();
+        this.toDip = in.readString();
+        this.message = in.readString();
+        this.stime = in.readLong();
+        this.etime = in.readLong();
+    }
+
+    public static final Parcelable.Creator<SAMDMessage> CREATOR = new Parcelable.Creator<SAMDMessage>()
+    {
+        @Override
+        public SAMDMessage[] newArray(int size)
+        {
+            // TODO Auto-generated method stub
+            return new SAMDMessage[size];
+        }
+
+        @Override
+        public SAMDMessage createFromParcel(Parcel in)
+        {
+            // TODO Auto-generated method stub
+            return new SAMDMessage(in);
+        }
+    };
+
+    @Override
+    public int describeContents()
+    {
+        // TODO Auto-generated method stub
+        return 0;
+    }
+
+    @Override
+    public void writeToParcel(Parcel dest, int flags)
+    {
+        dest.writeInt(this.fromDN);
+        dest.writeInt(this.toDN);
+        dest.writeString(this.fromDip);
+        dest.writeString(this.toDip);
+        dest.writeString(this.message);
+        dest.writeLong(this.stime);
+        dest.writeLong(this.etime);
+    }
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/view/LayoutInflater.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/view/LayoutInflater.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/view/LayoutInflater.java	2017-09-27 02:07:49.043736109 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/view/LayoutInflater.java	2017-02-15 17:11:09.797877000 +0900
@@ -70,7 +70,8 @@
 public abstract class LayoutInflater {
 
     private static final String TAG = LayoutInflater.class.getSimpleName();
-    private static final boolean DEBUG = false;
+    //private static final boolean DEBUG = false;
+    private static final boolean DEBUG = true;
 
     /**
      * This field should be made private, so it is hidden from the SDK.
@@ -108,6 +109,8 @@
     private static final int[] ATTRS_THEME = new int[] {
             com.android.internal.R.attr.theme };
 
+    private boolean isDummy = false;
+    
     /**
      * Hook to allow clients of the LayoutInflater to restrict the set of Views that are allowed
      * to be inflated.
@@ -373,6 +376,11 @@
     public View inflate(@LayoutRes int resource, @Nullable ViewGroup root) {
         return inflate(resource, root, root != null);
     }
+    
+    // ADDED FOR ABCMANAGER
+    public View inflate2(String key, @Nullable ViewGroup root) {
+        return inflate2(key, root, root != null);
+    }
 
     /**
      * Inflate a new view hierarchy from the specified xml node. Throws
@@ -420,6 +428,24 @@
 
         final XmlResourceParser parser = res.getLayout(resource);
         try {
+        	isDummy = false;
+            return inflate(parser, root, attachToRoot);
+        } finally {
+            parser.close();
+        }
+    }
+    
+    // ADDED FOR ABCMANAGER
+    public View inflate2(String key, @Nullable ViewGroup root, boolean attachToRoot) {
+        final Resources res = getContext().getResources();
+        /*if (DEBUG) {
+            Log.d(TAG, "INFLATING from resource: \"" + res.getResourceName(resource) + "\" ("
+                    + Integer.toHexString(resource) + ")");
+        }*/
+
+        final XmlResourceParser parser = res.getLayout(key);
+        try {
+        	isDummy = true;
             return inflate(parser, root, attachToRoot);
         } finally {
             parser.close();
@@ -832,10 +858,24 @@
             } else if (TAG_MERGE.equals(name)) {
                 throw new InflateException("<merge /> must be the root element");
             } else {
-                final View view = createViewFromTag(parent, name, context, attrs);
+            	final View view = createViewFromTag(parent, name, context, attrs);
                 final ViewGroup viewGroup = (ViewGroup) parent;
                 final ViewGroup.LayoutParams params = viewGroup.generateLayoutParams(attrs);
                 rInflateChildren(parser, view, attrs, true);
+                
+                if(isDummy)
+                {
+                    //collaboroid
+	                Log.d(TAG, "name: " + name + 
+	                		"\nattrs: " + attrs.toString() +
+	                		"\nid: " + view.getId() +
+	                		"\nhexid: " + Integer.toHexString(view.getId()) +
+	                		"\ntag: " + view.getTag() +
+	                		"\ncontext: " + context.toString() +
+	                		"\nentryName: " + view.getEntryName());
+	                context.getResources().getABC().addResource(view.getId());
+                }
+                
                 viewGroup.addView(view, params);
             }
         }
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/view/View.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/view/View.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/view/View.java	2017-09-27 02:07:49.051736109 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/view/View.java	2017-09-18 16:26:41.681836000 +0900
@@ -33,6 +33,7 @@
 import android.content.Context;
 import android.content.ContextWrapper;
 import android.content.Intent;
+import android.content.res.AssetManager;
 import android.content.res.ColorStateList;
 import android.content.res.Configuration;
 import android.content.res.Resources;
@@ -108,6 +109,7 @@
 import com.google.android.collect.Lists;
 import com.google.android.collect.Maps;
 
+import java.io.InputStream;
 import java.lang.annotation.Retention;
 import java.lang.annotation.RetentionPolicy;
 import java.lang.ref.WeakReference;
@@ -3429,6 +3431,9 @@
          */
         public OnClickListener mOnClickListener;
 
+
+
+
         /**
          * Listener used to dispatch long click events.
          * This field should be made private, so it is hidden from the SDK.
@@ -17212,6 +17217,20 @@
         mBackgroundResource = resid;
     }
 
+    //samd
+//    public void setImageSAMD(String resid) {
+//        try{
+//            Log.d("sbjsbj","setImageSAMD : " +resid);
+//            AssetManager am = mContext.getAssets();
+//            InputStream ims = am.open(resid);
+//            Drawable d = Drawable.createFromStream(ims, null);
+//            setBackground(d);
+//        }catch(Exception e){
+//            e.printStackTrace();
+//        }
+//    }
+
+
     /**
      * Set the background to a given Drawable, or remove the background. If the
      * background has padding, this View's padding is set to the background's
@@ -18475,6 +18494,11 @@
         return mID;
     }
 
+    public String getEntryName()
+    {
+    	return mResources.getResourceEntryName(mID);
+    }
+    
     /**
      * Returns this view's tag.
      *
@@ -21341,6 +21365,12 @@
         void onClick(View v);
     }
 
+    //collaboroid
+    public interface SAMDListener{
+
+        void onReceiveMessage();
+    }
+
     /**
      * Interface definition for a callback to be invoked when a view is context clicked.
      */
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/view/Window.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/view/Window.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/view/Window.java	2017-09-27 02:07:49.055736109 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/view/Window.java	2017-01-29 02:51:17.889869000 +0900
@@ -1043,7 +1043,10 @@
      * @see #setContentView(View, android.view.ViewGroup.LayoutParams)
      */
     public abstract void setContentView(@LayoutRes int layoutResID);
-
+    
+    // ADDED FOR ABCMANAGER
+    public abstract void setContentView2(String layoutResKey);
+    
     /**
      * Convenience for
      * {@link #setContentView(View, android.view.ViewGroup.LayoutParams)}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/widget/ImageView.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/widget/ImageView.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/widget/ImageView.java	2017-09-27 02:07:49.083736108 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/widget/ImageView.java	2017-09-21 13:32:22.444133000 +0900
@@ -21,6 +21,7 @@
 import android.annotation.Nullable;
 import android.content.ContentResolver;
 import android.content.Context;
+import android.content.res.AssetManager;
 import android.content.res.ColorStateList;
 import android.content.res.Resources;
 import android.content.res.TypedArray;
@@ -425,6 +426,18 @@
         invalidate();
     }
 
+    public void setImageResource(String resName) {
+        try{
+            AssetManager am = super.getContext().getAssets();
+            InputStream ims = am.open(resName);
+            Drawable d = Drawable.createFromStream(ims, null);
+            setImageDrawable(d);
+        }catch(Exception e){
+            e.printStackTrace();
+        }
+    }
+
+
     /**
      * Sets the content of this ImageView to the specified Uri.
      *
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/widget/LinearLayout.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/widget/LinearLayout.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/widget/LinearLayout.java	2017-09-27 02:07:49.083736108 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/widget/LinearLayout.java	2017-09-21 13:33:26.192760000 +0900
@@ -22,10 +22,12 @@
 import android.annotation.NonNull;
 import android.annotation.Nullable;
 import android.content.Context;
+import android.content.res.AssetManager;
 import android.content.res.TypedArray;
 import android.graphics.Canvas;
 import android.graphics.drawable.Drawable;
 import android.util.AttributeSet;
+import android.util.Log;
 import android.view.Gravity;
 import android.view.View;
 import android.view.ViewDebug;
@@ -33,6 +35,7 @@
 import android.view.ViewHierarchyEncoder;
 import android.widget.RemoteViews.RemoteView;
 
+import java.io.InputStream;
 import java.lang.annotation.Retention;
 import java.lang.annotation.RetentionPolicy;
 
diff -urN Android_6.0.1_r11/frameworks/base/core/java/com/android/internal/os/InstallerConnection.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/com/android/internal/os/InstallerConnection.java
--- Android_6.0.1_r11/frameworks/base/core/java/com/android/internal/os/InstallerConnection.java	2017-09-27 02:07:49.107736108 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/com/android/internal/os/InstallerConnection.java	2017-01-29 02:51:19.917891000 +0900
@@ -19,6 +19,7 @@
 import android.net.LocalSocket;
 import android.net.LocalSocketAddress;
 import android.os.SystemClock;
+import android.util.Log;
 import android.util.Slog;
 import libcore.io.IoUtils;
 import libcore.io.Streams;
@@ -27,6 +28,8 @@
 import java.io.InputStream;
 import java.io.OutputStream;
 
+
+
 /**
  * Represents a connection to {@code installd}. Allows multiple connect and
  * disconnect cycles.
@@ -117,6 +120,10 @@
         builder.append(' ');
         builder.append(outputPath != null ? outputPath : "!");
         builder.append(bootComplete ? " 1" : " 0");
+        
+        if(apkPath.contains("dummy") || pkgName.contains("dummy"))
+        	Log.d(TAG, builder.toString());
+        
         return execute(builder.toString());
     }
 
diff -urN Android_6.0.1_r11/frameworks/base/core/java/com/android/internal/os/WrapperInit.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/com/android/internal/os/WrapperInit.java
--- Android_6.0.1_r11/frameworks/base/core/java/com/android/internal/os/WrapperInit.java	2017-09-27 02:07:49.107736108 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/com/android/internal/os/WrapperInit.java	2017-01-29 02:51:19.929891000 +0900
@@ -17,6 +17,7 @@
 package com.android.internal.os;
 
 import android.os.Process;
+import android.util.Log;
 import android.util.Slog;
 
 import dalvik.system.VMRuntime;
@@ -118,6 +119,9 @@
         command.append(pipeFd != null ? pipeFd.getInt$() : 0);
         command.append(' ');
         command.append(targetSdkVersion);
+        
+        Log.d("execApp", command.toString());
+        
         Zygote.appendQuotedShellArgs(command, args);
         Zygote.execShell(command.toString());
     }
@@ -136,6 +140,9 @@
         StringBuilder command = new StringBuilder(invokeWith);
         command.append(" /system/bin/dalvikvm -classpath '").append(classPath);
         command.append("' ").append(className);
+        
+        Log.d("execSA", command.toString());
+        
         Zygote.appendQuotedShellArgs(command, args);
         Zygote.execShell(command.toString());
     }
diff -urN Android_6.0.1_r11/frameworks/base/core/java/com/android/internal/policy/PhoneWindow.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/com/android/internal/policy/PhoneWindow.java
--- Android_6.0.1_r11/frameworks/base/core/java/com/android/internal/policy/PhoneWindow.java	2017-09-27 02:07:49.111736108 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/com/android/internal/policy/PhoneWindow.java	2017-01-29 02:51:19.949891000 +0900
@@ -398,6 +398,30 @@
             cb.onContentChanged();
         }
     }
+    
+    public void setContentView2(String layoutResKey) {
+        // Note: FEATURE_CONTENT_TRANSITIONS may be set in the process of installing the window
+        // decor, when theme attributes and the like are crystalized. Do not check the feature
+        // before this happens.
+        if (mContentParent == null) {
+            installDecor();
+        } else if (!hasFeature(FEATURE_CONTENT_TRANSITIONS)) {
+            mContentParent.removeAllViews();
+        }
+
+        /*if (hasFeature(FEATURE_CONTENT_TRANSITIONS)) {
+            final Scene newScene = Scene.getSceneForLayout(mContentParent, layoutResID,
+                    getContext());
+            transitionTo(newScene);
+        } else {*/
+            mLayoutInflater.inflate2(layoutResKey, mContentParent);
+        //}
+        mContentParent.requestApplyInsets();
+        final Callback cb = getCallback();
+        if (cb != null && !isDestroyed()) {
+            cb.onContentChanged();
+        }
+    }
 
     @Override
     public void setContentView(View view) {
diff -urN Android_6.0.1_r11/frameworks/base/core/jni/AndroidRuntime.cpp SAMD_6.0.1_r11_20170930/frameworks/base/core/jni/AndroidRuntime.cpp
--- Android_6.0.1_r11/frameworks/base/core/jni/AndroidRuntime.cpp	2017-09-27 02:07:49.123736108 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/jni/AndroidRuntime.cpp	2016-11-01 17:36:40.402408000 +0900
@@ -105,6 +105,7 @@
  * JNI-based registration functions.  Note these are properly contained in
  * namespace android.
  */
+//extern int register_android_content_ABCManager(JNIEnv* env);
 extern int register_android_content_AssetManager(JNIEnv* env);
 extern int register_android_util_EventLog(JNIEnv* env);
 extern int register_android_util_Log(JNIEnv* env);
@@ -1298,6 +1299,7 @@
     REG_JNI(register_android_os_SystemClock),
     REG_JNI(register_android_util_EventLog),
     REG_JNI(register_android_util_Log),
+    //REG_JNI(register_android_content_ABCManager),
     REG_JNI(register_android_content_AssetManager),
     REG_JNI(register_android_content_StringBlock),
     REG_JNI(register_android_content_XmlBlock),
diff -urN Android_6.0.1_r11/frameworks/base/core/jni/android_util_AssetManager.cpp SAMD_6.0.1_r11_20170930/frameworks/base/core/jni/android_util_AssetManager.cpp
--- Android_6.0.1_r11/frameworks/base/core/jni/android_util_AssetManager.cpp	2017-09-27 02:07:49.155736108 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/jni/android_util_AssetManager.cpp	2017-04-09 22:11:25.809631000 +0900
@@ -211,6 +211,8 @@
         return -1;
     }
 
+    ALOGD("open asset - %s", fileName8.c_str());
+
     Asset* a = am->open(fileName8.c_str(), (Asset::AccessMode)mode);
 
     if (a == NULL) {
@@ -500,6 +502,9 @@
     return a->getRemainingLength();
 }
 
+
+//collaboroid resource sharing
+
 static jint android_content_AssetManager_addAssetPath(JNIEnv* env, jobject clazz,
                                                        jstring path)
 {
@@ -2171,6 +2176,13 @@
         (void*) android_content_AssetManager_getGlobalAssetManagerCount },
 };
 
+static JNINativeMethod gABCManagerMethods[] = {
+		{ "init",           "(Z)V",
+		        (void*) android_content_AssetManager_init },
+		{ "destroy",        "()V",
+		        (void*) android_content_AssetManager_destroy },
+};
+
 int register_android_content_AssetManager(JNIEnv* env)
 {
     jclass typedValue = FindClassOrDie(env, "android/util/TypedValue");
@@ -2203,8 +2215,13 @@
     gSparseArrayOffsets.put = GetMethodIDOrDie(env, gSparseArrayOffsets.classObject, "put",
                                                "(ILjava/lang/Object;)V");
 
-    return RegisterMethodsOrDie(env, "android/content/res/AssetManager", gAssetManagerMethods,
-                                NELEM(gAssetManagerMethods));
+    RegisterMethodsOrDie(env, "android/content/res/AssetManager", gAssetManagerMethods,
+                                    NELEM(gAssetManagerMethods));
+
+    RegisterMethodsOrDie(env, "android/content/res/ABCManager", gABCManagerMethods,
+                                    NELEM(gABCManagerMethods));
+
+    return 1;
 }
 
 }; // namespace android
diff -urN Android_6.0.1_r11/frameworks/base/docs/html/guide/topics/manifest/activity-element.jd SAMD_6.0.1_r11_20170930/frameworks/base/docs/html/guide/topics/manifest/activity-element.jd
--- Android_6.0.1_r11/frameworks/base/docs/html/guide/topics/manifest/activity-element.jd	2017-09-27 02:07:52.559736064 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/docs/html/guide/topics/manifest/activity-element.jd	2017-02-01 12:38:14.022453000 +0900
@@ -6,6 +6,7 @@
 <dl class="xml">
 <dt>syntax:</dt>
 <dd><pre class="stx">&lt;activity android:<a href="#embedded">allowEmbedded</a>=["true" | "false"]
+          android:<a href="#remoteable">remoteable</a>=["true" | "false"]
           android:<a href="#reparent">allowTaskReparenting</a>=["true" | "false"]
           android:<a href="#always">alwaysRetainTaskState</a>=["true" | "false"]
           android:<a href="#autoremrecents">autoRemoveFromRecents</a>=["true" | "false"]
@@ -71,6 +72,7 @@
 <dt>attributes:</dt>
 <dd><dl class="attr">
 <dt><a name="embedded"></a>{@code android:allowEmbedded}</dt>
+<dt><a name="remoteable"></a>{@code android:remoteable}</dt>
 <dd>
     Indicate that the activity can be launched as the embedded child of another
     activity. Particularly in the case where the child lives in a container
diff -urN Android_6.0.1_r11/frameworks/base/graphics/java/android/graphics/drawable/Drawable.java SAMD_6.0.1_r11_20170930/frameworks/base/graphics/java/android/graphics/drawable/Drawable.java
--- Android_6.0.1_r11/frameworks/base/graphics/java/android/graphics/drawable/Drawable.java	2017-09-27 02:07:54.207736042 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/graphics/java/android/graphics/drawable/Drawable.java	2017-02-15 16:21:48.158624000 +0900
@@ -41,6 +41,7 @@
 import android.os.Trace;
 import android.util.AttributeSet;
 import android.util.DisplayMetrics;
+import android.util.Log;
 import android.util.StateSet;
 import android.util.TypedValue;
 import android.util.Xml;
@@ -1221,6 +1222,7 @@
      * Create a drawable from file path name.
      */
     public static Drawable createFromPath(String pathName) {
+        Log.d("SBJSBJ createFromPath", "SBJSBJ createFromPath : " + pathName);
         if (pathName == null) {
             return null;
         }
